#
# $HeadURL: https://svn.oucs.ox.ac.uk/sysdev/src/packages/r/rb3/tags/1.43/lib/RB3/CLI/FindIface.pm $
# $LastChangedRevision: 28374 $
# $LastChangedDate: 2016-07-20 16:44:19 +0100 (Wed, 20 Jul 2016) $
# $LastChangedBy: oucs0146 $
#
package RB3::CLI::FindIface;

use strict;
use warnings FATAL => 'all';

use File::Spec;

use RB3::Interface;

sub cmd_find_iface {
    my $class = shift;
    my $app_config = shift;

    my $hostname = shift @ARGV
        or die "hostname not specified";

    my $sys_dir = File::Spec->catdir( $app_config->basedir, 'systems' );

    my $numhosts = 0;

    foreach my $host (RB3::Interface::parse_interfaces($hostname, $sys_dir)) {
	print "$host\n";
        $numhosts++;
    }

    # The address exists in DNS, but isn't in rb3, so fail quietly, rather
    # than die
    exit 3 if $numhosts == 0;

}

1;

__END__
